<?php

namespace Teknisa\CADCTB\Controllers;

use Teknisa\CADCTB\Services\Sap03200PeriodoFechamentoContabilGerencialService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CADCTB\Controllers\TeknisaCrud;
use Teknisa\CADCTB\Controllers\EntityManager;
use Teknisa\Libs\Util\Environment;

class Sap03200PeriodoFechamentoContabilGerencialController{
    
    protected $sap03200PeriodoFechamentoContabilGerencialService;
    protected $entityManager;
    protected $connection;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Sap03200PeriodoFechamentoContabilGerencialService $sap03200PeriodoFechamentoContabilGerencialService){
        $this->sap03200PeriodoFechamentoContabilGerencialService = $sap03200PeriodoFechamentoContabilGerencialService;
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function contabilizaSelecao(Row $row, Response $response) {
        $row = $row->getRow();
        $this->entityManager->beginTransaction();
        try{
            if($row['CDFILIAL'] == 'T'){
                $filiaisArray = $this->sap03200PeriodoFechamentoContabilGerencialService->getFiliaisFechamento($row);
            }else{
                $filiaisArray = [$row['CDFILIAL']];
            }
            
            $this->sap03200PeriodoFechamentoContabilGerencialService->contabilizaSelecao($row, $filiaisArray);
        }
        catch (\Exception $e) {
            $this->entityManager->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}