<?php
namespace Teknisa\CADCTB\Services;

use Teknisa\CADCTB\Factories\CtbGrupoProdutoFilialFactory;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;

class CtbGrupoProdutoFilialService {

	protected $environment;
	protected $entityManager;
	protected $ctb_grupo_produto_filialFactory; 

	public function __construct(Environment $environment, EntityManager $entityManager, CtbGrupoProdutoFilialFactory $ctbGrupoProdutoFilialFactory) {
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->factory = $ctbGrupoProdutoFilialFactory;
	}


	

    public function cadastroAutomaticoFilial($row) {
      try{
		//Organização Logada
		$nrorg = $this->environment->getNrOrgTrab();
		
		//Exclui registros Unidade de Destino
		$this->factory->excluiCctgrupprodfil($nrorg, $row['CDFILIAL2']);
	  
		//Busca registros Unidade de Origem
		$cctgrupprodfils_orig = $this->factory->buscaCctgrupprodfil($nrorg, $row['CDFILIAL']);
		
		//Verifica se existe registros pra Unidade de Origem
		if($cctgrupprodfils_orig){		
			//Percorre os registros da Unidade de Origem
			foreach($cctgrupprodfils_orig as $cctgrupprodfil_orig) {
				//Coloco Unidade de Destino na Origem para Inserir
				$cctgrupprodfil_orig['CDFILIAL'] = $row['CDFILIAL2'];
              
				//Insere Unidade de Destino
				$this->factory->insereCctgrupprodfil($nrorg, $cctgrupprodfil_orig);
			}
		}
    } catch(\Exception $e) {
        throw $e;
    }
}
}