/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: SEMANAL_PROX_DATA_ENTREGA                                            */
/*                                                                            */
/* Descrio:                                                                 */
/* Calcula datas de entrega para um determinado mes baseando-se na            */
/* Periodicidade de Entrega e nos Feriados de Compras.                        */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 08/01/99 - Yoris L. de Souza                                               */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/* @D:\SQLMAN~1\ORACLE\8000_CMPFUN_SEM_DATA_PROX_MES.SQL
/******************************************************************************/
/* PARAMETROS:                                                                */
/*                                                                            */
/* P_CDFILIAL     - Cdigo da Filial                                          */
/* P_CDPERIENTR   - Cdigo da Periodicidade de Entrega                        */
/* P_DTINICIAL    - Data do Inicio do Mes                                     */
/* P_IDDIANUTIL   - Considera dia nao util                                    */
/******************************************************************************/


CREATE OR REPLACE PROCEDURE SEMANAL_PROX_DATA_ENTREGA
  (P_CDFILIAL     IN VARCHAR2,
   P_CDPERIENTR   IN VARCHAR2,
   P_DTINICIAL    IN DATE,
   P_IDDIANUTIL   IN VARCHAR2,
   P_DTENTRAUX    OUT DATE)

 IS

   V_CONTAUXI   NUMBER;         
   V_DIENTREGA  VARCHAR2(2);   
   V_IDDIASEM   NUMBER;
   V_DTENTRAUX  DATE;
   V_PRIMVEZ    NUMBER;
  

/*--- CURSOR QUE CONTEM AS DATAS DE ENTREGA DO PROXIMO MES    ------*/
/*-   COM BASE NOS DIAS DE ENTREGA SEMANAIS                   ------*/

   CURSOR C_DATAS_PROX IS
(SELECT NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
        FROM DIASENTR
        WHERE
         CDPERIENTR = P_CDPERIENTR AND
         DIENTREGA = V_DIENTREGA AND
         IDOCOR01 = '1'
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
          ,V_IDDIASEM)
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            DIENTREGA = V_DIENTREGA AND
            IDOCOR02 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
           ,V_IDDIASEM),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM') 
UNION
        SELECT NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
          ,V_IDDIASEM),V_IDDIASEM)
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            DIENTREGA = V_DIENTREGA AND
            IDOCOR03 = '1' AND
           TO_CHAR(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
          ,V_IDDIASEM),V_IDDIASEM),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM') 

UNION
        SELECT NEXT_DAY(NEXT_DAY(
         NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
          ,V_IDDIASEM),V_IDDIASEM),V_IDDIASEM)
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            DIENTREGA = V_DIENTREGA AND
            IDOCOR04 = '1' AND
           TO_CHAR(NEXT_DAY(NEXT_DAY(
            NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL),V_IDDIASEM)
          ,V_IDDIASEM),V_IDDIASEM),V_IDDIASEM),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM') 

UNION
        SELECT NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1)-7,V_IDDIASEM)
          FROM DIASENTR
           WHERE
            CDPERIENTR = P_CDPERIENTR AND
            DIENTREGA = V_DIENTREGA AND
            IDOCOR05 = '1' AND
           TO_CHAR(NEXT_DAY(LAST_DAY(LAST_DAY(P_DTINICIAL)+1),V_IDDIASEM),'MM')
           = TO_CHAR(LAST_DAY(P_DTINICIAL)+1,'MM') );

BEGIN
    SELECT MIN(DIENTREGA) INTO V_DIENTREGA
    FROM DIASENTR
    WHERE
      CDPERIENTR = P_CDPERIENTR;

    V_IDDIASEM := TO_NUMBER(V_DIENTREGA);

/*- PEGA A PRIMEIRA DATA ANTERIOR A PROXIMA ENTREGA  -*/
    OPEN C_DATAS_PROX;
    FETCH C_DATAS_PROX
    INTO V_DTENTRAUX;
    CLOSE C_DATAS_PROX;

    IF P_IDDIANUTIL = 'S' THEN
     V_CONTAUXI := 1;
      WHILE V_CONTAUXI > 0 LOOP
        SELECT COUNT(*) INTO V_CONTAUXI
        FROM FERICOMP
        WHERE
        CDFILIAL = P_CDFILIAL AND 
        DTFERICOMP = V_DTENTRAUX;
        IF V_CONTAUXI > 0 THEN
           V_DTENTRAUX := V_DTENTRAUX - 1;
        END IF;
      END LOOP;
    END IF;
    V_DTENTRAUX := V_DTENTRAUX - 1;
    P_DTENTRAUX := V_DTENTRAUX;

END;
/
