const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po.js');
const termoAberturaLegal = require('../../../page-objects/parametrizacao/contabil/termoAbertura.po.js');
const termoGridId = '1917279887127344376997';
describe('Tela Termo de Abertura e Encerramento', () => {
	beforeAll(() => {
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		geral.abrir(['Parametrização', 'Contábil', 'Termo de Abertura e Encerramento']);
		z.component.footer.clickRightActionByLabel('Filtrar', true);
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${termoGridId}`)));
	});

	afterAll(() => {
		geral.sair();
	});

	it('Deve acessar a tela Termo de Abertura e Encerramento', () => {
		expect(z.component.header.getTitle()).toBe('Termo de Abertura e Encerramento');
	});

	it('Deve adicionar uma termo', () => {
		geral.clickAdicionar();
		termoAberturaLegal.adicionar(j.getValor('unidade'), j.getValor('CodLivro'),
			j.getValor('modeloTermo'), j.getValor('pagInicial'), j.getValor('pagFinal'),
			j.getValor('numeroPagina'), j.getValor('numeroLivro'));
		geral.clickSalvar();

		expect(geral.gridHasText(termoGridId, j.getValor('numeroLivro'), 7))
			.toBe(j.getValor('numeroLivro'));
	});

	it('Deve editar registro', () => {
		geral.clickGrid('NRLIVROESCRITU', j.getValor('numeroLivro'), termoGridId);
		geral.clickEditar();
		termoAberturaLegal.editar(j.getValor('pagInicial1'), j.getValor('pagFinal1'),
			j.getValor('numeroPagina1'), j.getValor('numeroLivro1'));
		geral.clickSalvar();
		geral.clickVoltar();
		expect(geral.gridHasText(termoGridId, j.getValor('numeroLivro1'), 7))
			.toBe(j.getValor('numeroLivro1'));
	});

	it('Deve excluir um termo de Abertura', () => {
		geral.clickGrid('NRLIVROESCRITU', j.getValor('numeroLivro1'), termoGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(termoGridId, j.getValor('numeroLivro1'), 7))
			.toBeUndefined();
	});
});
